## jackd2 1.9.8~dfsg.4+20121110git67ac4440

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8
from __future__ import print_function

import os
import Utils
import Options
import subprocess
g_maxlen = 40
import shutil
import Task
import re
import Logs
import sys

VERSION='1.9.9'
APPNAME='jack'
JACK_API_VERSION = '0.1.0'

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

def display_msg(msg, status = None, color = None):
    sr = msg
    global g_maxlen
    g_maxlen = max(g_maxlen, len(msg))
    if status:
        Logs.pprint('NORMAL', "%s :" % msg.ljust(g_maxlen), sep=' ')
        Logs.pprint(color, status)
    else:
        print("%s" % msg.ljust(g_maxlen))

def display_feature(msg, build):
    if build:
        display_msg(msg, "yes", 'GREEN')
    else:
        display_msg(msg, "no", 'YELLOW')

def create_svnversion_task(bld, header='svnversion.h', define=None):
    cmd = '../svnversion_regenerate.sh ${TGT}'
    if define:
        cmd += " " + define

    def post_run(self):
        sg = Utils.h_file(self.outputs[0].abspath(self.env))
        #print sg.encode('hex')
        Build.bld.node_sigs[self.env.variant()][self.outputs[0].id] = sg

    bld(
            rule = cmd,
            name = 'svnversion',
            runnable_status = Task.RUN_ME,
            before = 'c',
            color = 'BLUE',
            post_run = post_run,
            target = [bld.path.find_or_declare(header)]
    )

def options(opt):
    # options provided by the modules
    opt.tool_options('compiler_cxx')
    opt.tool_options('compiler_cc')

    opt.add_option('--libdir', type='string', help="Library directory [Default: <prefix>/lib]")
    opt.add_option('--libdir32', type='string', help="32bit Library directory [Default: <prefix>/lib32]")
    opt.add_option('--mandir', type='string', help="Manpage directory [Default: <prefix>/share/man/man1]")
    opt.add_option('--dbus', action='store_true', default=False, help='Enable D-Bus JACK (jackdbus)')
    opt.add_option('--classic', action='store_true', default=False, help='Force enable standard JACK (jackd) even if D-Bus JACK (jackdbus) is enabled too')
    opt.add_option('--doxygen', action='store_true', default=False, help='Enable build of doxygen documentation')
    opt.add_option('--profile', action='store_true', default=False, help='Build with engine profiling')
    opt.add_option('--mixed', action='store_true', default=False, help='Build with 32/64 bits mixed mode')
    opt.add_option('--clients', default=64, type="int", dest="clients", help='Maximum number of JACK clients')
    opt.add_option('--ports-per-application', default=768, type="int", dest="application_ports", help='Maximum number of ports per application')
    opt.add_option('--debug', action='store_true', default=False, dest='debug', help='Build debuggable binaries')
    opt.add_option('--firewire', action='store_true', default=False, help='Enable FireWire driver (FFADO)')
    opt.add_option('--freebob', action='store_true', default=False, help='Enable FreeBob driver')
    opt.add_option('--alsa', action='store_true', default=False, help='Enable ALSA driver')
    opt.sub_options('dbus')

def configure(conf):
    conf.load('compiler_cxx')
    conf.load('compiler_cc')
    platform = sys.platform
    conf.env['IS_MACOSX'] = platform == 'darwin'
    conf.env['IS_LINUX'] = platform == 'linux' or platform == 'linux2' or platform == 'posix'
    conf.env['IS_SUN'] = platform == 'sunos'
    # GNU/kFreeBSD and GNU/Hurd are treated as Linux
    if platform.startswith('gnu0') or platform.startswith('gnukfreebsd'):
        conf.env['IS_LINUX'] = True

    if conf.env['IS_LINUX']:
        Logs.pprint('CYAN', "Linux detected")

    if conf.env['IS_MACOSX']:
        Logs.pprint('CYAN', "MacOS X detected")

    if conf.env['IS_SUN']:
        Logs.pprint('CYAN', "SunOS detected")

    if conf.env['IS_LINUX']:
        conf.check_tool('compiler_cxx')
        conf.check_tool('compiler_cc')

    if conf.env['IS_MACOSX']:
        conf.check_tool('compiler_cxx')
        conf.check_tool('compiler_cc')

    # waf 1.5 : check_tool('compiler_cxx') and check_tool('compiler_cc') do not work correctly, so explicit use of gcc and g++
    if conf.env['IS_SUN']:
        conf.check_tool('g++')
        conf.check_tool('gcc')

    #if conf.env['IS_SUN']:
    #   conf.check_tool('compiler_cxx')
    #   conf.check_tool('compiler_cc')
 
    conf.env.append_unique('CXXFLAGS', '-Wall')
    conf.env.append_unique('CFLAGS', '-Wall')

    conf.sub_config('common')
    if conf.env['IS_LINUX']:
        conf.sub_config('linux')
        if Options.options.alsa and not conf.env['BUILD_DRIVER_ALSA']:
            conf.fatal('ALSA driver was explicitly requested but cannot be built')
        if Options.options.freebob and not conf.env['BUILD_DRIVER_FREEBOB']:
            conf.fatal('FreeBob driver was explicitly requested but cannot be built')
        if Options.options.firewire and not conf.env['BUILD_DRIVER_FFADO']:
            conf.fatal('FFADO driver was explicitly requested but cannot be built')
        conf.env['BUILD_DRIVER_ALSA'] = Options.options.alsa
        conf.env['BUILD_DRIVER_FFADO'] = Options.options.firewire
        conf.env['BUILD_DRIVER_FREEBOB'] = Options.options.freebob
    if Options.options.dbus:
        conf.sub_config('dbus')
        if conf.env['BUILD_JACKDBUS'] != True:
            conf.fatal('jackdbus was explicitly requested but cannot be built')

    conf.check_cc(header_name='samplerate.h', define_name="HAVE_SAMPLERATE")

    if conf.is_defined('HAVE_SAMPLERATE'):
        conf.env['LIB_SAMPLERATE'] = ['samplerate']

    conf.sub_config('example-clients')

    if conf.check_cfg(package='celt', atleast_version='0.11.0', args='--cflags --libs', mandatory=False):
        conf.define('HAVE_CELT', 1)
        conf.define('HAVE_CELT_API_0_11', 1)
        conf.define('HAVE_CELT_API_0_8', 0)
        conf.define('HAVE_CELT_API_0_7', 0)
        conf.define('HAVE_CELT_API_0_5', 0)
    elif conf.check_cfg(package='celt', atleast_version='0.8.0', args='--cflags --libs', mandatory=False):
        conf.define('HAVE_CELT', 1)
        conf.define('HAVE_CELT_API_0_11', 0)
        conf.define('HAVE_CELT_API_0_8', 1)
        conf.define('HAVE_CELT_API_0_7', 0)
        conf.define('HAVE_CELT_API_0_5', 0)
    elif conf.check_cfg(package='celt', atleast_version='0.7.0', args='--cflags --libs', mandatory=False):
        conf.define('HAVE_CELT', 1)
        conf.define('HAVE_CELT_API_0_11', 0)
        conf.define('HAVE_CELT_API_0_8', 0)
        conf.define('HAVE_CELT_API_0_7', 1)
        conf.define('HAVE_CELT_API_0_5', 0)
    elif conf.check_cfg(package='celt', atleast_version='0.5.0', args='--cflags --libs', mandatory=False):
        conf.define('HAVE_CELT', 1)
        conf.define('HAVE_CELT_API_0_11', 0)
        conf.define('HAVE_CELT_API_0_8', 0)
        conf.define('HAVE_CELT_API_0_7', 0)
        conf.define('HAVE_CELT_API_0_5', 1)
    else:
        conf.define('HAVE_CELT', 0)
        conf.define('HAVE_CELT_API_0_11', 0)
        conf.define('HAVE_CELT_API_0_8', 0)
        conf.define('HAVE_CELT_API_0_7', 0)
        conf.define('HAVE_CELT_API_0_5', 0)

    conf.env['WITH_OPUS'] = False
    if conf.check_cfg(package='opus', atleast_version='0.9.0' , args='--cflags --libs', mandatory=False):
        if conf.check_cc(header_name='opus/opus_custom.h', mandatory=False):
            conf.define('HAVE_OPUS', 1)
            conf.env['WITH_OPUS'] = True


    conf.env['LIB_PTHREAD'] = ['pthread']
    conf.env['LIB_DL'] = ['dl']
    conf.env['LIB_RT'] = ['rt']
    conf.env['LIB_M'] = ['m']
    conf.env['LIB_STDC++'] = ['stdc++']
    conf.env['JACK_API_VERSION'] = JACK_API_VERSION
    conf.env['JACK_VERSION'] = VERSION

    conf.env['BUILD_DOXYGEN_DOCS'] = Options.options.doxygen
    conf.env['BUILD_WITH_PROFILE'] = Options.options.profile
    conf.env['BUILD_WITH_32_64'] = Options.options.mixed
    conf.env['BUILD_CLASSIC'] = Options.options.classic
    conf.env['BUILD_DEBUG'] = Options.options.debug

    if conf.env['BUILD_JACKDBUS']:
        conf.env['BUILD_JACKD'] = conf.env['BUILD_CLASSIC']
    else:
        conf.env['BUILD_JACKD'] = True

    if Options.options.libdir:
        conf.env['LIBDIR'] = Options.options.libdir
    else:
        conf.env['LIBDIR'] = conf.env['PREFIX'] + '/lib'

    if Options.options.mandir:
        conf.env['MANDIR'] = Options.options.mandir
    else:
        conf.env['MANDIR'] = conf.env['PREFIX'] + '/share/man/man1'

    if conf.env['BUILD_DEBUG']:
        conf.env.append_unique('CXXFLAGS', '-g')
        conf.env.append_unique('CFLAGS', '-g')
        conf.env.append_unique('LINKFLAGS', '-g')

    conf.define('CLIENT_NUM', Options.options.clients)
    conf.define('PORT_NUM_FOR_CLIENT', Options.options.application_ports)

    conf.env['ADDON_DIR'] = os.path.normpath(os.path.join(conf.env['LIBDIR'], 'jack'))
    conf.define('ADDON_DIR', conf.env['ADDON_DIR'])
    conf.define('JACK_LOCATION', os.path.normpath(os.path.join(conf.env['PREFIX'], 'bin')))
    conf.define('USE_POSIX_SHM', 1)
    conf.define('JACKMP', 1)
    if conf.env['BUILD_JACKDBUS'] == True:
        conf.define('JACK_DBUS', 1)
        if conf.env['BUILD_JACKD'] == False:
            conf.define('USE_LIBDBUS_AUTOLAUNCH', 1)
    if conf.env['BUILD_WITH_PROFILE'] == True:
        conf.define('JACK_MONITOR', 1)
    conf.write_config_header('config.h', remove=False)

    svnrev = None
    if os.access('svnversion.h', os.R_OK):
        data = file('svnversion.h').read()
        m = re.match(r'^#define SVN_VERSION "([^"]*)"$', data)
        if m != None:
            svnrev = m.group(1)

    if Options.options.mixed == True:
        env_variant2 = conf.env.copy()
        conf.set_env_name('lib32', env_variant2)
        env_variant2.set_variant('lib32')
        conf.setenv('lib32')
        conf.env.append_unique('CXXFLAGS', '-m32')
        conf.env.append_unique('CFLAGS', '-m32')
        conf.env.append_unique('LINKFLAGS', '-m32')
        if Options.options.libdir32:
            conf.env['LIBDIR'] = Options.options.libdir32
        else:
            conf.env['LIBDIR'] = conf.env['PREFIX'] + '/lib32'
        conf.write_config_header('config.h')

    print()
    display_msg("==================")
    version_msg = "JACK " + VERSION
    if svnrev:
        version_msg += " exported from r" + svnrev
    else:
        version_msg += " svn revision will checked and eventually updated during build"
    print(version_msg)

    print("Build with a maximum of %d JACK clients" % Options.options.clients)
    print("Build with a maximum of %d ports per application" % Options.options.application_ports)
 
    display_msg("Install prefix", conf.env['PREFIX'], 'CYAN')
    display_msg("Library directory", conf.env['LIBDIR'], 'CYAN')
    display_msg("Drivers directory", conf.env['ADDON_DIR'], 'CYAN')
    display_feature('Build debuggable binaries', conf.env['BUILD_DEBUG'])
    display_msg('C compiler flags', repr(conf.env['CFLAGS']))
    display_msg('C++ compiler flags', repr(conf.env['CXXFLAGS']))
    display_msg('Linker flags', repr(conf.env['LINKFLAGS']))
    display_feature('Build doxygen documentation', conf.env['BUILD_DOXYGEN_DOCS'])
    display_feature('Build Opus netjack2', conf.env['WITH_OPUS'])
    display_feature('Build with engine profiling', conf.env['BUILD_WITH_PROFILE'])
    display_feature('Build with 32/64 bits mixed mode', conf.env['BUILD_WITH_32_64'])

    display_feature('Build standard JACK (jackd)', conf.env['BUILD_JACKD'])
    display_feature('Build D-Bus JACK (jackdbus)', conf.env['BUILD_JACKDBUS'])

    if conf.env['BUILD_JACKDBUS'] and conf.env['BUILD_JACKD']:
        print(Logs.colors.RED + 'WARNING !! mixing both jackd and jackdbus may cause issues:' + Logs.colors.NORMAL)
        print(Logs.colors.RED + 'WARNING !! jackdbus does not use .jackdrc nor qjackctl settings' + Logs.colors.NORMAL)

    if conf.env['IS_LINUX']:
        display_feature('Build with ALSA support', conf.env['BUILD_DRIVER_ALSA'] == True)

=== common/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import Build
import re
import os

def configure(conf):
    conf.check_cc(header_name='samplerate.h', define_name="HAVE_SAMPLERATE")
   
    if conf.is_defined('HAVE_SAMPLERATE'):
        conf.env['LIB_SAMPLERATE'] = ['samplerate']

    conf.env['BUILD_NETLIB'] = conf.is_defined('HAVE_SAMPLERATE')
    conf.env['BUILD_ADAPTER'] = conf.is_defined('HAVE_SAMPLERATE')

def create_jack_process_obj(bld, target, sources, uselib = None):
    process = bld(features = ['cxx', 'cxxshlib'])
    process.env['cxxshlib_PATTERN'] = '%s.so'
    process.defines  = ['HAVE_CONFIG_H','SERVER_SIDE']
    if bld.env['IS_MACOSX']:
        env_includes = ['../macosx', '../posix', '../macosx/coreaudio']
    if bld.env['IS_LINUX']:
        env_includes = ['../linux', '../posix', '../linux/alsa']
    if bld.env['IS_SUN']:
        env_includes = ['../solaris', '../posix', '../solaris/oss']
    process.includes = ['.'] + env_includes + ['jack', '..']
    process.name     = target
    process.target   = target
    process.source   = sources
    if bld.env['IS_LINUX']:
        process.env.append_value("CPPFLAGS", "-fvisibility=hidden")
    if bld.env['IS_MACOSX']:
        process.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc -arch x86_64")
        #process.env.append_value("LINKFLAGS", "-arch i386 -arch ppc -arch x86_64")
        process.env.append_value("CPPFLAGS", "-fvisibility=hidden")
    process.install_path = '${ADDON_DIR}/'
    process.use = [uselib.name]
    return process

def build(bld):
    common_libsources = [
        'JackActivationCount.cpp',
        'JackAPI.cpp',
        'JackClient.cpp',
        'JackConnectionManager.cpp',
        'ringbuffer.c',
        'JackError.cpp',
        'JackException.cpp',
        'JackFrameTimer.cpp',
        'JackGraphManager.cpp',
        'JackPort.cpp',
        'JackPortType.cpp',
        'JackAudioPort.cpp',
        'JackMidiPort.cpp',
        'JackMidiAPI.cpp',
        'JackEngineControl.cpp',
        'JackShmMem.cpp',
        'JackGenericClientChannel.cpp',
        'shm.c',
        'JackGlobals.cpp',
        'JackDebugClient.cpp',
        'JackTransportEngine.cpp',
        'timestamps.c',
        'JackTools.cpp',
        'JackMessageBuffer.cpp',
        'JackEngineProfiling.cpp',
        ]

    includes = ['.', './jack', '..']
    uselib = ["PTHREAD", "CELT", "OPUS"]

    if bld.env['IS_LINUX']:
        common_libsources += [
            '../posix/JackPosixThread.cpp',
            '../posix/JackPosixSemaphore.cpp',
            '../posix/JackPosixProcessSync.cpp',
            '../posix/JackPosixMutex.cpp',
            '../posix/JackSocket.cpp',
            '../linux/JackLinuxTime.c',
            ]
        includes = ['../linux', '../posix'] + includes
        uselib.append('RT')
        uselib.append('DL')

    if bld.env['IS_SUN']:
        common_libsources += [
           '../posix/JackPosixThread.cpp',
           '../posix/JackFifo.cpp',
           '../posix/JackPosixProcessSync.cpp',
           '../posix/JackPosixMutex.cpp',
           '../posix/JackSocket.cpp',
           '../solaris/JackSolarisTime.c',
           ]
        includes = ['../solaris', '../posix'] + includes
        uselib.append('RT')

    if bld.env['IS_MACOSX']:
        common_libsources += [
            '../posix/JackPosixProcessSync.cpp',
            '../posix/JackPosixThread.cpp',
            '../macosx/JackMachThread.cpp',
            '../macosx/JackMachSemaphore.cpp',
            '../posix/JackSocket.cpp',
            '../macosx/JackMachTime.c',
            ]
        includes = ['../macosx', '../macosx/RPC', '../posix'] + includes

    serverlib = bld(features = ['c', 'cxx', 'cxxshlib', 'cshlib'])
    serverlib.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
    serverlib.includes = includes
    serverlib.name         = 'serverlib'
    serverlib.target       = 'jackserver'
    serverlib.use = uselib
    serverlib.install_path = '${LIBDIR}'
    serverlib.source = [] + common_libsources
    serverlib.source += [
        'JackAudioDriver.cpp',
        'JackTimedDriver.cpp',
        'JackMidiDriver.cpp',
        'JackDriver.cpp',
        'JackEngine.cpp',
        'JackExternalClient.cpp',
        'JackFreewheelDriver.cpp',
        'JackInternalClient.cpp',
        'JackServer.cpp',
        'JackThreadedDriver.cpp',
        'JackRestartThreadedDriver.cpp',
        'JackWaitThreadedDriver.cpp',
        'JackServerAPI.cpp',
        'JackDriverLoader.cpp',
        'JackServerGlobals.cpp',
        'JackControlAPI.cpp',
        'JackNetTool.cpp',
        'JackNetInterface.cpp',
        'JackArgParser.cpp',
        'JackRequestDecoder.cpp',
        'JackMidiAsyncQueue.cpp',
        'JackMidiAsyncWaitQueue.cpp',
        'JackMidiBufferReadQueue.cpp',
        'JackMidiBufferWriteQueue.cpp',
        'JackMidiRawInputWriteQueue.cpp',
        'JackMidiRawOutputWriteQueue.cpp',
        'JackMidiReadQueue.cpp',
        'JackMidiReceiveQueue.cpp',
        'JackMidiSendQueue.cpp',
        'JackMidiUtil.cpp',
        'JackMidiWriteQueue.cpp'
        ]

    if bld.env['IS_LINUX']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    if bld.env['IS_SUN']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    if bld.env['IS_MACOSX']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    serverlib.vnum = bld.env['JACK_API_VERSION']

    if bld.env['IS_LINUX']:
        serverlib.env.append_value("CPPFLAGS", "-fvisibility=hidden")

    if bld.env['IS_MACOSX']:
        serverlib.env.append_value("CPPFLAGS", "-fvisibility=hidden")
        serverlib.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc -arch x86_64")
        #serverlib.env.append_value("LINKFLAGS", "-framework CoreAudio -framework vecLib -single_module -arch i386 -arch ppc -arch x86_64")
        serverlib.env.append_value("LINKFLAGS", "-framework CoreAudio -framework CoreFoundation -framework vecLib -single_module")
        serverlib.env.append_value("LINKFLAGS", "-compatibility_version 1 -current_version 1")

    if bld.env['IS_SUN']:
        serverlib.env.append_value("LINKFLAGS", "-lnsl -lsocket")

    if bld.env['BUILD_NETLIB'] == True:
        netlib = bld(features = ['c', 'cxx', 'cxxshlib', 'cshlib'])
        netlib.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
        netlib.includes = includes
        netlib.name         = 'netlib'
        netlib.target       = 'jacknet'
        netlib.use = ['SAMPLERATE', 'CELT', 'OPUS', 'PTHREAD' , 'RT']
        netlib.install_path = '${LIBDIR}'
        netlib.source = [
            'JackNetAPI.cpp',
            'JackNetInterface.cpp',
            'JackNetTool.cpp',
            'JackException.cpp',
            'JackAudioAdapterInterface.cpp',
            'JackLibSampleRateResampler.cpp',
            'JackResampler.cpp',
            'JackGlobals.cpp',
            '../posix/JackPosixMutex.cpp',
            'ringbuffer.c']

        if bld.env['IS_LINUX']:
            netlib.source += ['../posix/JackNetUnixSocket.cpp','../posix/JackPosixThread.cpp', '../linux/JackLinuxTime.c']
            netlib.env.append_value("CPPFLAGS", "-fvisibility=hidden")

        if bld.env['IS_SUN']:
            netlib.source += ['../posix/JackNetUnixSocket.cpp','../posix/JackPosixThread.cpp', '../solaris/JackSolarisTime.c']
            netlib.env.append_value("CPPFLAGS", "-fvisibility=hidden")
       

        if bld.env['IS_MACOSX']:
            netlib.source += ['../posix/JackNetUnixSocket.cpp','../posix/JackPosixThread.cpp', '../macosx/JackMachThread.cpp', '../macosx/JackMachTime.c']
            netlib.env.append_value("LINKFLAGS", "-framework CoreAudio -single_module")

        netlib.vnum = bld.env['JACK_API_VERSION']

    clientlib = bld(features = ['c', 'cxx', 'cxxshlib', 'cshlib'])
    clientlib.defines = 'HAVE_CONFIG_H'
    clientlib.use = uselib
    clientlib.install_path = '${LIBDIR}'
    if bld.env['BUILD_JACKDBUS'] == True and bld.env['BUILD_JACKD'] == False:
        clientlib.use.append('DBUS-1')
    clientlib.includes = includes
    clientlib.name         = 'clientlib'
    clientlib.target       = 'jack'
    clientlib.source = [] + common_libsources
    clientlib.source += [
        'JackLibClient.cpp',
        'JackLibAPI.cpp',
        ]

    if bld.env['IS_LINUX']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_SUN']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_MACOSX']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    clientlib.vnum = bld.env['JACK_API_VERSION']

    if bld.env['IS_LINUX']:
        clientlib.env.append_value("CPPFLAGS", "-fvisibility=hidden")
    
    if bld.env['IS_MACOSX']:
        clientlib.env.append_value("CPPFLAGS", "-fvisibility=hidden")
        clientlib.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc -arch x86_64")
        #clientlib.env.append_value("LINKFLAGS", "-framework CoreAudio -framework vecLib -single_module -arch i386 -arch ppc -arch x86_64"
        clientlib.env.append_value("LINKFLAGS", "-framework CoreAudio -framework vecLib -single_module")
        clientlib.env.append_value("LINKFLAGS", "-compatibility_version 1 -current_version 1")

    if bld.env['IS_SUN']:
        clientlib.env.append_value("LINKFLAGS", "-lnsl -lsocket")

    if bld.env['BUILD_WITH_32_64']:
        print("create 32bit lib...")
        clientlib32bit = clientlib.clone('lib32')
  
    create_jack_process_obj(bld, 'netmanager', 'JackNetManager.cpp', serverlib)

    create_jack_process_obj(bld, 'profiler', 'JackProfiler.cpp', serverlib)

    net_adapter_sources = [
        'JackResampler.cpp',
        'JackLibSampleRateResampler.cpp',
        'JackAudioAdapter.cpp',
        'JackAudioAdapterInterface.cpp',
        'JackNetAdapter.cpp',
        ]

    if bld.env['BUILD_ADAPTER'] == True:
        process = create_jack_process_obj(bld, 'netadapter', net_adapter_sources, serverlib)
        process.use = 'SAMPLERATE'

    audio_adapter_sources = [
        'JackResampler.cpp',
        'JackLibSampleRateResampler.cpp',
        'JackAudioAdapter.cpp',
        'JackAudioAdapterInterface.cpp',
        'JackAudioAdapterFactory.cpp',
         ]

    if bld.env['BUILD_ADAPTER'] and bld.env['IS_MACOSX']:
         audio_adapter_sources += ['../macosx/coreaudio/JackCoreAudioAdapter.cpp']
         process = create_jack_process_obj(bld, 'audioadapter', audio_adapter_sources, serverlib)
         process.env.append_value("LINKFLAGS", "-framework CoreAudio -framework AudioUnit -framework AudioToolbox -framework CoreServices")
         process.use = 'SAMPLERATE'

    if bld.env['BUILD_ADAPTER'] and bld.env['IS_LINUX'] and bld.env['BUILD_DRIVER_ALSA']:
         audio_adapter_sources += ['../linux/alsa/JackAlsaAdapter.cpp']
         process = create_jack_process_obj(bld, 'audioadapter', audio_adapter_sources, serverlib)
         process.use = ['ALSA', 'SAMPLERATE']

    if bld.env['BUILD_ADAPTER'] and bld.env['IS_SUN']:
         audio_adapter_sources += ['../solaris/oss/JackOSSAdapter.cpp', 'memops.c']

=== example-clients/wscript ===
#! /usr/bin/env python
# encoding: utf-8

example_programs = {
    'jack_freewheel' : 'freewheel.c',
    'jack_connect' : 'connect.c',
    'jack_lsp' : 'lsp.c',
    'jack_metro' : 'metro.c',
    'jack_midiseq' : 'midiseq.c',
    'jack_midisine' : 'midisine.c',
    'jack_showtime' : 'showtime.c',
    'jack_simple_client' : 'simple_client.c',
    'jack_zombie' : 'zombie.c',
    'jack_load' : 'ipload.c',
    'jack_unload' : 'ipunload.c',
    'jack_showtime' : 'showtime.c',
    'jack_alias' : 'alias.c',
    'jack_bufsize' : 'bufsize.c',
    'jack_wait' : 'wait.c',
    'jack_samplerate' : 'samplerate.c',
    'jack_evmon' : 'evmon.c',
    'jack_monitor_client' : 'monitor_client.c',
    'jack_thru' : 'thru_client.c',
    'jack_cpu_load' : 'cpu_load.c',
    'jack_simple_session_client' : 'simple_session_client.c',
    'jack_session_notify' : 'session_notify.c',
    'jack_server_control' : 'server_control.cpp',
    'jack_net_slave' : 'netslave.c',
    'jack_net_master' : 'netmaster.c',
    'jack_latent_client' : 'latent_client.c',
    'jack_midi_dump' : 'midi_dump.c',
    'jack_midi_latency_test' : 'midi_latency_test.c'
    }

example_libs = {
    'inprocess' : 'inprocess.c',
    }

def configure(conf):
    e = conf.check_cc(header_name='sndfile.h', define_name="HAVE_SNDFILE")
 
    if conf.is_defined('HAVE_SNDFILE'):
        conf.env['LIB_SNDFILE'] = ['sndfile']

    conf.check_cfg(package='celt', atleast_version='0.5.0', args='--cflags --libs', mandatory=False)

    e = conf.check_cc(lib='readline', define_name="HAVE_READLINE", mandatory=False)

    # define_name="HAVE_READLINE" has no effect, LIB_READLINE is defined if readline is available
    #if conf.is_defined('HAVE_READLINE'):
    #    conf.env['LIB_READLINE'] = ['readline']

    conf.env['BUILD_EXAMPLE_CLIENT_TRANSPORT'] = bool(conf.env['LIB_READLINE'])

    conf.env['BUILD_EXAMPLE_CLIENT_REC'] = conf.is_defined('HAVE_SNDFILE')

    conf.env['BUILD_EXAMPLE_ALSA_IO'] = conf.is_defined('HAVE_SAMPLERATE') and conf.env['BUILD_DRIVER_ALSA']

def build(bld):
    if bld.env['IS_LINUX']:
        os_incdir = ['../linux', '../posix']
    if bld.env['IS_MACOSX']:
        os_incdir = ['../macosx', '../posix']
    if bld.env['IS_SUN']:
        os_incdir = ['../solaris', '../posix']
    for example_program, example_program_source in list(example_programs.items()):
        if example_program == 'jack_server_control':
            use = ['serverlib']
        elif example_program == 'jack_net_slave':
            if not bld.env['BUILD_NETLIB']:
                continue
            use = ['netlib']
        elif example_program == 'jack_net_master':
            if not bld.env['BUILD_NETLIB']:
                continue
            use = ['netlib']
        else:
            use = ['clientlib']

        prog = bld(features='c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = example_program_source
        prog.use = use
        if bld.env['IS_MACOSX']:
            prog.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc -arch x86_64")
            #prog.env.append_value("LINKFLAGS", "-arch i386 -arch ppc -arch x86_64")
            prog.env.append_value("LINKFLAGS", "")
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'M']
        if bld.env['IS_SUN']:
            prog.use += ['M']

        prog.target = example_program
   
    if bld.env['BUILD_EXAMPLE_CLIENT_TRANSPORT']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = 'transport.c'
        prog.use = ['clientlib']
        if bld.env['IS_MACOSX']:
            prog.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc -arch x86_64")
            #prog.env.append_value("LINKFLAGS", "-arch i386 -arch ppc -arch x86_64")
            prog.env.append_value("LINKFLAGS", "")
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'READLINE']
        if bld.env['IS_MACOSX']:
            prog.use += ['READLINE']
        prog.target = 'jack_transport'

    if bld.env['BUILD_EXAMPLE_CLIENT_REC']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = 'capture_client.c'
        prog.use = ['clientlib']
        if bld.env['IS_MACOSX']:
            prog.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc -arch x86_64")
            #prog.env.append_value("LINKFLAGS", "-arch i386 -arch ppc -arch x86_64")
            prog.env.append_value("LINKFLAGS", "")
            prog.use += ['SNDFILE']
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'SNDFILE']
        if bld.env['IS_SUN']:
            prog.use += ['RT', 'SNDFILE']
        prog.target = 'jack_rec'

    if bld.env['IS_LINUX'] or bld.env['IS_MACOSX']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['.', '..', '../common/jack', '../common']
        prog.source = ['netsource.c', '../common/netjack_packet.c']
        prog.env.append_value("CFLAGS", "-DNO_JACK_ERROR")
        prog.use = ['CELT', 'SAMPLERATE', 'OPUS', 'M', 'clientlib']
        prog.target = 'jack_netsource'
        prog.defines = ['HAVE_CONFIG_H']

    if bld.env['IS_LINUX'] and bld.env['BUILD_EXAMPLE_ALSA_IO']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = ['alsa_in.c', '../common/memops.c']
        prog.env.append_value("CFLAGS", "-DNO_JACK_ERROR")
        prog.use = ['clientlib', 'ALSA', 'SAMPLERATE', 'M']
        prog.target = 'alsa_in'

        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = ['alsa_out.c', '../common/memops.c']
        prog.env.append_value("CFLAGS", "-DNO_JACK_ERROR")
        prog.use = ['clientlib', 'ALSA', 'SAMPLERATE', 'M']
        prog.target = 'alsa_out'

    for example_lib, example_lib_source in list(example_libs.items()):
        lib = bld(features = 'c cshlib')
        lib.env['cshlib_PATTERN'] = '%s.so'
        lib.includes = os_incdir + ['../common/jack', '../common']
        lib.target = example_lib
        lib.source = example_lib_source
        if bld.env['IS_MACOSX']:
            lib.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc -arch x86_64")
            #lib.env.append_value("LINKFLAGS", "-arch i386 -arch ppc -arch x86_64")
            lib.env.append_value("LINKFLAGS", "")
        if bld.env['IS_SUN']:
            lib.env.append_value("LINKFLAGS", "-lm")
        lib.use = 'serverlib'
        lib.install_path = '${ADDON_DIR}/'

    bld.symlink_as('${PREFIX}/bin/jack_disconnect', 'jack_connect')

    bld.install_files('${PREFIX}/bin', 'jack_control', chmod=0o755)

=== debian/changelog ===
jackd2 (1.9.8~dfsg.4+20121110git67ac4440-1) experimental; urgency=low

  * Imported Upstream version 1.9.8~dfsg.4+20121110git67ac4440
    (Closes: #682792)
  * Fix FTBFS on ppc64 (Closes: #684470)
  * Switch to dh_python2 (Closes: #676922)
  * Refresh no-selfconnect.patch

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Sat, 10 Nov 2012 11:01:03 +0100

=== debian/control ===
Source: jackd2
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Adrian Knoth <adi@drcomp.erfurt.thur.de>, Jonas Smedegaard <dr@jones.dk>, Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper (>= 9~),
 cdbs (>= 0.4.93~),
 debhelper (>= 8.1.3),
 d-shlibs,
 python (>= 2.6.6-3~),
 libsamplerate-dev,
 libasound2-dev (>= 1.0.18) [linux-any],
 libdbus-1-dev,
 libexpat1-dev,
 libsndfile1-dev,
 libncurses-dev,
 libreadline-dev,
 libraw1394-dev [linux-any],
 libffado-dev (>= 2.0.0) [amd64 i386 powerpc],
 po-debconf
Standards-Version: 3.9.3
DM-Upload-Allowed: yes
Homepage: http://jackaudio.org/
Vcs-Git: git://git.debian.org/git/pkg-multimedia/jackd2.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/jackd2.git;a=summary

Package: jackd2
Architecture: any
Replaces: libjack0 (<= 1.9.5~dfsg-13),
	jackd (<< 3),
	jack-daemon
Provides: jack-daemon
Conflicts: jack-daemon,
	jackd (<< 3)
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${python:Depends},
 coreutils (>= 4.0),
 python-dbus,
 debconf | debconf-2.0,
 libjack-jackd2-0 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Recommends: qjackctl,
 libpam-modules,
 jackd2-firewire [amd64 i386 powerpc]
Suggests: jack-tools,
 meterbridge
Description: JACK Audio Connection Kit (server and example clients)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the daemon jackd as well as some example clients.

Package: libjack-jackd2-0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
 ${misc:Depends}
Conflicts: jackd2 (>> ${binary:Version}),
 jackd2 (<< ${binary:Version}),
 libjack0,
 libjack-0.116
Suggests: jackd2 (= ${binary:Version})
Provides: libjack-0.116
Replaces: libjack-0.116
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: JACK Audio Connection Kit (libraries)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the shared libraries.

Package: jackd2-firewire
Architecture: amd64 i386 powerpc
Provides: jackd-firewire
Replaces: jackd-firewire
Conflicts: jackd-firewire
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends},
 jackd2 (= ${binary:Version})
Description: JACK Audio Connection Kit (FFADO and FreeBoB backends)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the IEEE1394 (FireWire) backends FFADO and FreeBoB.

Package: libjack-jackd2-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libjack-jackd2-0 (= ${binary:Version}), 
 ${asound:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
 pkg-config,
 libdbus-1-dev
Conflicts: libjack0.100.0-dev (<< 0.102.20-2),
 libjack-dev
Provides: libjack0.100.0-dev,
 libjack-dev-session,
 libjack-dev
Replaces: libjack0.71.2-0 (<< 0.75.0-1)
Description: JACK Audio Connection Kit (development files)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains files needed for the development of JACK applications
 and an API reference.
